function subscribe(fn) {
  this.subscribers.push(fn);
}

function unsubscribe(fn) {
  this.subscribers = this.subscribers.filter(function (f) {
    return f !== fn;
  });
}

function setState(getState) {
  var _this = this;

  this.state = Object.assign({}, this.state, typeof getState === "function" ? getState(this.state) : getState);
  return Promise.all(this.subscribers.map(function (sub) {
    return sub(_this.state);
  }));
}

function createState(initialState) {
  return {
    state: initialState,
    subscribers: [],
    setState: setState,
    subscribe: subscribe,
    unsubscribe: unsubscribe
  };
}

module.exports = createState;
